package eu.etaxonomy.taxeditor.designproposal2.view;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.text.ITextViewer;
import org.eclipse.jface.text.contentassist.CompletionProposal;
import org.eclipse.jface.text.contentassist.ContextInformation;
import org.eclipse.jface.text.contentassist.ICompletionProposal;
import org.eclipse.jface.text.contentassist.IContentAssistProcessor;
import org.eclipse.jface.text.contentassist.IContextInformation;
import org.eclipse.jface.text.contentassist.IContextInformationValidator;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;

import com.swtdesigner.ResourceManager;

import eu.etaxonomy.taxeditor.designproposal2.Activator;

public class MyCompletionProcessor implements IContentAssistProcessor {

	protected final static String[] myProposals = { "Unknown synonymy", 
							"Create homotypic synonym",
							"Create heterotypic synoynm",
							"Create basionym",
							"Create replaced synonym",
							"Create homonym",
							"Create orthographic variant",
							"Create misapplied name",
							"Create concept relation"};
	protected final static String[] myIcons = { "icons/unknown.gif", 
							"icons/homosyn.gif", 
							"icons/heterosyn.gif",
							"icons/basionym.gif",
							"icons/repsyn.gif",
							"icons/homonym.gif",
							"icons/orthovariant.gif",
							"icons/misapplied.gif",
							"icons/concept.gif"};
	protected final static String[] myContexts = { "To create a homotypic synonym, there are many things to consider. I could go on all day.",
							"Create homotypic synonym",
							"Create heterotypic synoynm",
							"Create basionym",
							"Create replaced synonym",
							"Create homonym",
							"Create orthographic variant",
							"Create misapplied name",
							"Create concept relation"};
	
	/* (non-Javadoc)
	 * Method declared on IContentAssistProcessor
	 */
	public ICompletionProposal[] computeCompletionProposals(
		ITextViewer viewer, int documentOffset) {
		String context = "Describe formatting / parsing of this rel. type.";
//		Image img = ResourceManager.getPluginImage(Activator.getDefault(), "icons/unknown.gif");
		ICompletionProposal[] result =
			new ICompletionProposal[myProposals.length];
		for (int i = 0; i < myProposals.length; i++) {
		      IContextInformation contextInfo = 
			         new ContextInformation(null, myProposals[i]+" Style");
			result[i] = new CompletionProposal(myProposals[i],documentOffset, 0, 
					myProposals[i].length(), ResourceManager.getPluginImage(Activator.getDefault(), myIcons[i]), 
					myProposals[i], contextInfo, context);

		}
		return result;
	}

	/* (non-Javadoc)
	 * Method declared on IContentAssistProcessor
	 */
	public char[] getCompletionProposalAutoActivationCharacters() {
		return new char[] { '=', (char) SWT.CR };
	}

	/* (non-Javadoc)
	 * Method declared on IContentAssistProcessor
	 */
	public char[] getContextInformationAutoActivationCharacters() {
		return null;
	}

	// For Context information 
	/* (non-Javadoc)
	 * Method declared on IContentAssistProcessor
	 */
	public IContextInformationValidator getContextInformationValidator() {
		return null;
	}

	/* (non-Javadoc)
	 * Method declared on IContentAssistProcessor
	 */
	public IContextInformation[] computeContextInformation(
		ITextViewer viewer,
		int documentOffset) {
		return null;
	}

	/* (non-Javadoc)
	 * Method declared on IContentAssistProcessor
	 */
	public String getErrorMessage() {
		return null;
	}
}
