package eu.etaxonomy.taxeditor.prototype2.controller;

import org.eclipse.jface.action.Action;

import eu.etaxonomy.cdm.model.name.BotanicalName;
import eu.etaxonomy.cdm.model.name.Rank;
import eu.etaxonomy.cdm.model.taxon.Taxon;

/**
 * Opens a name editor for a new taxon with a parent taxon
 * 
 * @author p.ciardelli
 *
 */
public class ActionOpenNewChildNameEditor extends Action {

	private Taxon taxon;
	public static final String ID = "eu.etaxonomy.taxeditor.prototype2.controller.opennameeditoraction"; //$NON-NLS-1$
	
	public ActionOpenNewChildNameEditor(Taxon parentTaxon) {
		
		taxon = new Taxon();
		taxon.setName(new BotanicalName(Rank.GENUS()));
		
		// TODO getTitleCache is currently returning "null", not null
		//  hence its being set here - change!
		taxon.getName().setTitleCache(null);
		
		parentTaxon.addTaxonomicChild(taxon, null, null);
	}

	public ActionOpenNewChildNameEditor() {
		setId(ID);
	}
	
	public void run() {
		new ActionOpenNameEditor(taxon).run();
	}
}