package eu.etaxonomy.taxeditor.prototype2.view.nameviewersupport;

import java.util.Scanner;

import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.BadPositionCategoryException;
import org.eclipse.jface.text.DocumentEvent;
import org.eclipse.jface.text.IRegion;
import org.eclipse.jface.text.ITypedRegion;
import org.eclipse.jface.text.rules.FastPartitioner;
import org.eclipse.jface.text.rules.IPartitionTokenScanner;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.widgets.Control;

import eu.etaxonomy.taxeditor.prototype2.view.NameEditorView;

public class NamePartitioner extends FastPartitioner {

	private NameEditorView nameEditorView;
	private Control precedingControl;

	public NamePartitioner(IPartitionTokenScanner scanner,
			String[] legalContentTypes, 
			NameEditorView nameEditorView, Control precedingControl) { 
		super(scanner, legalContentTypes);
		this.nameEditorView = nameEditorView;
		this.precedingControl = precedingControl;
	}
	
	protected void initialize() {
		
		// if there is unparsed text, put it in the document's taxonname
//		fDocument.addPosition(new Position());
		
		super.initialize();
		try {
			System.out.println(this.getPositions().length + " positions in new sourceviewer");
		} catch (BadPositionCategoryException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public IRegion documentChanged2_(DocumentEvent e) {

		System.out.println("we're in");
		
		String text = e.getText();
		int length = e.getLength();
		int offset = e.getOffset();
		int docLength = e.getDocument().getLength(); // length of doc BEFORE insert
		
		if (text.contains(System.getProperty("line.separator"))) {
			if (offset < docLength) {
			// remove text following insert from document,
			//  add to insert text	 
				try {
					text += e.getDocument().get(offset, docLength - offset);
					e.getDocument().replace(offset, docLength - offset, "");
				} catch (BadLocationException e1) {
					System.out.println(e1.getMessage());
					e1.printStackTrace();
				}
			}	
			
			Scanner scanner = new Scanner( text );
			scanner.useDelimiter (System.getProperty("line.separator"));
			
			StyledText SText = (StyledText) precedingControl;
			nameEditorView.createRelatedName(SText, "test");
			StyledText lastSText = null;
			while (scanner.hasNext()) {
				if (lastSText == null)
					e.getDocument().set(scanner.next());
				else
					SText = nameEditorView.createRelatedName(SText, scanner.next()).
							getTextWidget();
				lastSText = SText;
			}	
			
			SText.setFocus();
			
			// put cursor at EOL of last sourceviewer
			SText.setCaretOffset(SText.getText().length()); 
			
			return null;
		} 
		
//		System.out.println("we made it this far");
		
		return super.documentChanged2(e);
	}
	
	public ITypedRegion[] computePartitioning(int offset, int length, boolean includeZeroLengthPartitions) {
		System.out.println("computePartitioning called\n\t" + offset + "\n\t" + length + "\n\t" + includeZeroLengthPartitions);
		return super.computePartitioning(offset, length, includeZeroLengthPartitions);
	}
}
