/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy 
 * http://www.e-taxonomy.eu
 * 
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.actions.cdm;

import org.apache.log4j.Logger;
import org.eclipse.jface.action.Action;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.cdm.model.taxon.TaxonRelationship;
import eu.etaxonomy.cdm.model.taxon.TaxonRelationshipType;
import eu.etaxonomy.taxeditor.ITaxEditorConstants;

/**
 * @author p.ciardelli
 * @created 22.05.2008
 * @version 1.0
 */
public class DeleteRelatedTaxonFromAcceptedTaxonAction extends Action {
	private static final Logger logger = Logger
			.getLogger(DeleteRelatedTaxonFromAcceptedTaxonAction.class);

	private Taxon relatedTaxon;
	private Taxon acceptedTaxon;

	public DeleteRelatedTaxonFromAcceptedTaxonAction(Taxon relatedTaxon, Taxon acceptedTaxon) {
		super();
		this.relatedTaxon = relatedTaxon;
		this.acceptedTaxon = acceptedTaxon;
	}

	public void run() {
	
		for (TaxonRelationship relation : relatedTaxon.getTaxonRelations()) {
			if (relation.getToTaxon().equals(acceptedTaxon)) {
				acceptedTaxon.removeTaxonRelation(relation);
			}
		}
	}
}