/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy 
 * http://www.e-taxonomy.eu
 * 
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.actions.cdm;

import org.apache.log4j.Logger;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.resource.ImageDescriptor;

import eu.etaxonomy.cdm.model.name.TaxonNameBase;
import eu.etaxonomy.taxeditor.ITaxEditorConstants;
import eu.etaxonomy.taxeditor.TaxEditorPlugin;
import eu.etaxonomy.taxeditor.model.CdmUtil;

/**
 * @author p.ciardelli
 * @created 26.05.2008
 * @version 1.0
 */
public class MakeGroupBasionymAction extends Action {
	private static final Logger logger = Logger
			.getLogger(MakeGroupBasionymAction.class);

	private static String text = "Set as basionym for homotypical group";
	private ImageDescriptor image = TaxEditorPlugin.getDefault()
			.getImageDescriptor(ITaxEditorConstants.BASIONYM_ICON);

	private TaxonNameBase basionymName;

	public MakeGroupBasionymAction() {
		super(text);
		setImageDescriptor(image);
	}

	public MakeGroupBasionymAction(TaxonNameBase basionymName) {
		this();
		this.basionymName = basionymName;
	}

	public void run() {
		CdmUtil.setGroupBasionym(basionymName);
				
		firePropertyChange(ITaxEditorConstants.BASIONYM, null, basionymName);
	}
}
