/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy 
 * http://www.e-taxonomy.eu
 * 
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.actions.cdm;

import org.apache.log4j.Logger;

import eu.etaxonomy.cdm.model.name.TaxonNameBase;
import eu.etaxonomy.cdm.model.reference.ReferenceBase;
import eu.etaxonomy.cdm.model.taxon.Synonym;
import eu.etaxonomy.cdm.model.taxon.Taxon;

/**
 * @author p.ciardelli
 * @created 23.05.2008
 * @version 1.0
 */
public class TaxonActionFactory {
	private static final Logger logger = Logger
			.getLogger(TaxonActionFactory.class);

	Taxon taxon;

	private TaxonActionFactory(Taxon taxon) {
		this.taxon = taxon;
	}

	public static TaxonActionFactory newInstance(Taxon taxon) {
		return new TaxonActionFactory(taxon);
	}
	
	public void deleteSynonymFromTaxon(Synonym synonym, Taxon taxon) {
		new DeleteSynonymFromTaxonAction(synonym, taxon).run();
	}

	public Taxon addMisappliedNameToTaxon(TaxonNameBase name,
			ReferenceBase citation, String microcitation, Taxon taxon) {
		AddMisappliedNameToTaxonAction misappliedNameAction = new AddMisappliedNameToTaxonAction(
				name, null, null, taxon);
		misappliedNameAction.run();
		Taxon misappliedNameTaxon = misappliedNameAction
				.getMisappliedNameTaxon();
		return misappliedNameTaxon;
	}

}
