/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.actions.io;

import java.io.File;

import org.apache.log4j.Logger;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.FileDialog;

import eu.etaxonomy.taxeditor.UiUtil;

/**
 * @author p.ciardelli
 * @created 05.11.2008
 * @version 1.0
 */
public class ExportAction extends Action {
	private static final Logger logger = Logger.getLogger(ExportAction.class);

	private static String text = "Export as ...";
	private ImageDescriptor image = null;
	public static final String ID = "eu.etaxonomy.taxeditor.actions.io.exportaction"; //$NON-NLS-1$

	public static final String JAXB = "JAXB";

	private FileDialog dialog;
	private File file;

	private String exportType;
	
	public ExportAction() {
		super(text);
		setImageDescriptor(image);
		setId(ID);
	}

	public ExportAction(String exportType) {
		this();
		
		this.exportType = exportType;
		setText(exportType);
	}

	public void run() {

		// Use same title "Import FORMAT" for all message dialogs
		String title = "Export " + getText();
		
		// Get file from user
		dialog = new FileDialog(UiUtil.getShell(), SWT.SAVE);
		dialog.setFileName("export.xml");
		String filePath = dialog.open();
		file = new File(filePath);		
	}
}
